#include "game.h"
#include "board.h"
#include "libmy/key.h"
#include "libmy/adrv.h"
#include "libmy/gbfs.h"


//---------------------------------------------------------------------------
ST_GAME Game;


//---------------------------------------------------------------------------
EWRAM_CODE void GameInit()
{
	Game.state = GAME_INIT;
}
//---------------------------------------------------------------------------
EWRAM_CODE void GameExec()
{
	switch(Game.state)
	{
	case GAME_INIT:
		BoardInit();
		Game.state = GAME_BOARD;
		break;

	case GAME_BOARD:
		BoardExec();

		if(BoardIsSel() == TRUE)
		{
			BoardExecPlay();
		}
		break;

	default:
		SystemError("[Err] GameExec State");
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void GameDraw()
{
	BoardDraw();
}
