#ifndef __BG_H__
#define __BG_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "../libgba/gba.h"

//---------------------------------------------------------------------------
#define BG_MAX_CNT				4

#define BG_FONT_SCX				20
#define BG_FONT_SCY				10
#define BG_FONT_DAT_SIZE		128
#define BG_FONT_INVALID_INDEX	5		// G[̃CfbNXR[h "E"


//---------------------------------------------------------------------------
typedef struct {
	u32  mapBase;
	u16* mapBaseAdr;
	u32  tileBase;
	u16* tileBaseAdr;
} ST_BG;


typedef struct {
	u8 sig[2];
	u8 ver;
	u8 size;
	u8 index;
	u8 reserved[11];
} __PACKED ST_CCT_HEAD;


typedef struct {
	u8 count;
	u8 reserved[3];
} __PACKED ST_CCT_ENT;


typedef struct {
	u8  start;
	u8  end;
	u16 offset;
} __PACKED ST_CCT_INFO;


typedef struct {
	u16* pDat;			// tHgf[^
	u8*  pCct;			// tHgV[g
} ST_BG_SJIS;


//---------------------------------------------------------------------------
EWRAM_CODE void BgInit();
EWRAM_CODE void BgInitLcd();
EWRAM_CODE void Bg0Init();
EWRAM_CODE void Bg1Init();
EWRAM_CODE void Bg2Init();
EWRAM_CODE void Bg3Init();


EWRAM_CODE void Bg1On();
EWRAM_CODE void Bg1Off();


//----
EWRAM_CODE void Bg1DrawChr(u16 x, u16 y, u16 chr);


//----
EWRAM_CODE void BgAsciiInit();
IWRAM_CODE void BgAsciiDrawStr(u16 x, u16 y, char* s);


//----
EWRAM_CODE void BgSjisInit();
IWRAM_CODE void BgSjisDrawStr(u16 x, u16 y, char* str);
IWRAM_CODE void BgSjisDrawChr(u16 x, u16 y, u16 chr);
IWRAM_CODE u16  BgSjisGetIdx(u16 chr);


#ifdef __cplusplus
}
#endif
#endif
