#ifndef __LEX_H__
#define __LEX_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "../libgba/gba.h"


//---------------------------------------------------------------------------
#define LEX_MAX_CNT			3
#define LEX_MAX_STR_CNT		128

enum {
	TOKEN_NUM,
	TOKEN_STR,
	TOKEN_CUM,
	TOKEN_SKIP,
	TOKEN_CR,
	TOKEN_LF,
	TOKEN_END,
};

//---------------------------------------------------------------------------
typedef struct {
	bool  isUse;
	char* pCur;						// J[\
	char* pOld;						// UnGetpJ[\
	u16   id;						// g[NID
	s32   num;						//  or ̒
	char  str[LEX_MAX_STR_CNT];		// 
} ST_LEX;


//---------------------------------------------------------------------------
EWRAM_CODE void  LexInit();
EWRAM_CODE s16   LexOpen(char* pCur);
EWRAM_CODE void  LexClose(u16 fd);

EWRAM_CODE s32   LexGetNum(u16 fd);
EWRAM_CODE char* LexGetStr(u16 fd);
EWRAM_CODE char  LexGetChr(u16 fd);
EWRAM_CODE s32   LexGetSafeNum(u16 fd);
EWRAM_CODE char* LexGetSafeStr(u16 fd);
EWRAM_CODE char  LexGetSafeChr(u16 fd);

EWRAM_CODE char  LexGetChrNoSeek(u16 fd);
EWRAM_CODE char  LexTestSafeChr(char chr);


EWRAM_CODE void  LexGetToken(u16 fd, bool isChr);
EWRAM_CODE u16   LexGetId(char chr);
EWRAM_CODE bool  LexSeekTag(u16 fd, char* str);
EWRAM_CODE void  LexNextLine(u16 fd);
EWRAM_CODE void  LexUnGet(u16 fd);

EWRAM_CODE bool  LexIsEnd(u16 fd);

#ifdef __cplusplus
}
#endif
#endif
