#ifndef __AC_H__
#define __AC_H__


#include "gba.h"


//---------------------------------------------------------------------------
#define AC_MAX_SCALE_CNT			12
#define AC_MAX_TRACK_CNT			4
#define AC_MAX_CODE_BUF_CNT			0x3fff		// u8Pʁi*4āA0xffff𒴂Ȃ悤Ɂj

#define AC_NO_DATA					0x0000

enum {
	C2 = 0,
	Cs2	,
	D2	,
	Ds2	,
	E2	,
	F2	,
	Fs2	,
	G2	,
	Gs2	,
	A2	,
	As2	,
	B2	,
	C3	,
	Cs3	,
	D3	,
	Ds3	,
	E3	,
	F3	,
	Fs3	,
	G3	,
	Gs3	,
	A3	,
	As3	,
	B3	,
	C4	,
	Cs4	,
	D4	,
	Ds4	,
	E4	,
	F4	,
	Fs4	,
	G4	,
	Gs4	,
	A4	,
	As4	,
	B4	,
	C5	,
	Cs5	,
	D5	,
	Ds5	,
	E5	,
	F5	,
	Fs5	,
	G5	,
	Gs5	,
	A5	,
	As5	,
	B5	,
	C6	,
	Cs6	,
	D6	,
	Ds6	,
	E6	,
	F6	,
	Fs6	,
	G6	,
	Gs6	,
	A6	,
	As6	,
	B6	,
	C7	,
	Cs7	,
	D7	,
	Ds7	,
	E7	,
	F7	,
	Fs7	,
	G7	,
	Gs7	,
	A7	,
	As7	,
	B7	,			// 
	CMD_DUMMY,		// _~[
	CMD_R,			// x
	CMD_Q,			// Q[g
	CMD_P,			// p|bg
	CMD_W,			// f[eB
	CMD_S,			// Xebv^C
	CMD_D,			// f`[(g炵)
	CMD_ECHO,		// GR[
	CMD_ECHOVOL,	// GR[{E
	CMD_AND,		// ^C
	CMD_TAI,		// ^C
	CMD_LOOPBEGIN,	// [vJn
	CMD_LOOPEND,	// [vI
	CMD_VOLUME,		// 
	CMD_TONE,		// F
	CMD_TRACKLOOP,	// gbN擪ɖ߂
	CMD_TRACKEND,	// gbNI


	CMD_MATUYOSI_SW,		// XB[v(ch1 only)
	CMD_MATUYOSI_PL,		// p^[EOX(all channel)
	CMD_MATUYOSI_EV,		// Gx[v(ch1,ch2 only)
	CMD_MATUYOSI_VL,		// {[(ch3 only)
	CMD_MATUYOSI_SP,

	CMD_DUMMY_END,
};


//---------------------------------------------------------------------------
// egbÑXe[^X
typedef struct {
	bool isUse;

	u8   codeBuf[AC_MAX_CODE_BUF_CNT];
	s32  codeCnt;

	s32  octave;
	s32  volume;
	s32  length;
	s32  allLength;

} ST_AC_TRACK;


// AChCo{
typedef struct {
	u32 curTrack;
	ST_AC_TRACK track[AC_MAX_TRACK_CNT];

} ST_AC;


// ͗p
typedef struct {
	char* pBuf;
	s32   lineCnt;

	char* pOldBuf;
	s32   oldLineCnt;

} ST_LEX;


// yf[^̃wb_
typedef struct {
	char id[8];			// 'ANDRIVER'
	u16  offset[4];		// egbN̐擪̈ʒuB0̏ꍇɂ́ÃgbNgp

} __PACKED ST_AC_HEADER;


//---------------------------------------------------------------------------
void AcInit();
void AcExec(u8* pBuf);
void AcSave(char* pFileName);

u8   AcCalcOctave(u16 note);

void AcPutCmd(u16 cmd, u16 param);
void AcPutNote(u16 cmd, u16 length);
void AcAddNote(u16 length);
void AcChkCmd(u16 cmd, u16 param);
bool AcChkCmdSub(u16 param, u16 min, u16 max);

void AcSetCurTrack(u32 trackNum);
void AcSetOctave(s32 octave);
s32  AcGetOctave();


#endif
